#include "repere.h"
#include <GL/glu.h>

	
pRepere creeRepere(float longueur) {

	pRepere r = (pRepere) malloc (sizeof (tRepere));
	
	r->longueur = longueur;
	
	return r;
}


void traceRepere (pRepere r) {

#define DIAMETRECYLINDRE (1./30.0)
#define DIAMETRECONE (1./15.0)


	GLUquadricObj* quad = gluNewQuadric();
	
	float specular [] = {0.9,0.9,0.9,1.};
	float shininess = 70.;
	
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);

	/* Axe X */
	glColor3d(1.0,0.0,0.0);
	glPushMatrix();
	glRotatef(90,0.0,1.0,0.0);
	gluCylinder(quad, r->longueur*DIAMETRECYLINDRE, r->longueur*DIAMETRECYLINDRE, 0.8*r->longueur, 10, 10);
	glTranslatef(0.0,0.0,0.8*r->longueur);
	gluCylinder(quad, r->longueur*DIAMETRECONE, 0.0, 0.2*r->longueur, 10, 10);
	glPopMatrix();
	/* Axe Y */
	glColor3d(0.0,1.0,0.0);
	glPushMatrix();
	glRotatef(-90,1.0,0.0,0.0);
	gluCylinder(quad, r->longueur*DIAMETRECYLINDRE, r->longueur*DIAMETRECYLINDRE, 0.8*r->longueur, 10, 10);
	glTranslatef(0.0,0.0,0.8*r->longueur);
	gluCylinder(quad, r->longueur*DIAMETRECONE, 0.0, 0.2*r->longueur, 10, 10);
	glPopMatrix();
	/* Axe Z */
	glColor3d(0.0,0.0,1.0);
	glPushMatrix();
	gluCylinder(quad, r->longueur*DIAMETRECYLINDRE, r->longueur*DIAMETRECYLINDRE, 0.8*r->longueur, 10, 10);
	glTranslatef(0.0,0.0,0.8*r->longueur);
	gluCylinder(quad, r->longueur*DIAMETRECONE, 0.0, 0.2*r->longueur, 10, 10);
	glPopMatrix();
	
	glDisable(GL_COLOR_MATERIAL);
}

